<template>
  <h3>Edit user: {{ first_name + " " + last_name }}</h3>

  <el-row :gutter="3">
    <el-col :span="12">
      <el-input v-model="first_name" placeholder="Enter first name" />
      <span class="error" v-show="!validFirst_name"
        >Enter first name 3 to 255 symbols</span
      >
    </el-col>
    <el-col :span="12">
      <el-input v-model="last_name" placeholder="Enter last name" />
      <span class="error" v-show="!validLast_name"
        >Enter last name 3 to 255 symbols</span
      >
    </el-col>
  </el-row>

  <el-row :gutter="3">
    <el-col :span="12">
      <el-input v-model="email" type="email" placeholder="Enter email" />
      <span class="error" v-show="!validEmail">Enter valid email</span>
    </el-col>
    <el-col :span="12">
      <el-input
        v-model="password"
        show-password
        placeholder="Enter last_name"
      />
    </el-col>
  </el-row>

  <el-button :disabled="!validFields" @click="updateUser">Save</el-button>
</template>

<script>
  import userModelMixin from "./userModelMixin";

  export default {
    mixins: [userModelMixin],
    mounted() {
      this.axios(`/user/${this.uuid}`).then((data) => {
        if (data.status == 200) {
          this.first_name = data.data.first_name;
          this.last_name = data.data.last_name;
          this.email = data.data.email;
          this.password = data.data.password;
        }
      });
    },

    methods: {
      updateUser() {
        this.axios
          .post(`/user/${this.uuid}`, {
            first_name: this.first_name,
            last_name: this.last_name,
            email: this.email,
            password: this.password,
          })
          .then((data) => {
            if (data.status == 200) {
              this.$router.push({ name: "Home" });
            }
          })
          .catch((error) => {
            this.$notify.error({
              title: "Error",
              message: error.response.data,
            });
          });
      },
    },
  };
</script>

<style scoped>
  .error {
    color: tomato;
  }

  .el-input {
    margin: 3px;
    padding: 5px;
  }
</style>